<template>
    <div class="bg-white">
        <div class="pt-6">
            <nav aria-label="Breadcrumb">
                <ol role="list" class="max-w-2xl mx-auto px-4 flex items-center space-x-2 sm:px-6 lg:max-w-7xl lg:px-8">
                    <li>
                        <div class="flex items-center">
                            <a :href="route('products')" class="mr-2 text-sm font-medium text-gray-900">
                                Все продукты
                            </a>
                            <svg width="16" height="20" viewBox="0 0 16 20" fill="currentColor" xmlns="http://www.w3.org/2000/svg" aria-hidden="true" class="w-4 h-5 text-gray-300">
                                <path d="M5.697 4.34L8.98 16.532h1.327L7.025 4.341H5.697z" />
                            </svg>
                        </div>
                    </li>
                    <li>
                        <div class="flex items-center">
                            <a :href="'/products/' + product.category.code" class="mr-2 text-sm font-medium text-gray-900">
                                {{ product.category.name }}
                            </a>
                            <svg width="16" height="20" viewBox="0 0 16 20" fill="currentColor" xmlns="http://www.w3.org/2000/svg" aria-hidden="true" class="w-4 h-5 text-gray-300">
                                <path d="M5.697 4.34L8.98 16.532h1.327L7.025 4.341H5.697z" />
                            </svg>
                        </div>
                    </li>
                    <li class="text-sm">
                        <span class="font-medium text-gray-500 hover:text-gray-600">
                            {{ product.name }}
                        </span>
                    </li>
                </ol>
            </nav>

            <!-- Image gallery -->
            <div class="mt-6 max-w-2xl mx-auto sm:px-6 lg:max-w-7xl lg:px-8 lg:grid lg:grid-cols-3 lg:gap-x-8">
                <div class="hidden aspect-w-3 aspect-h-4 rounded-lg overflow-hidden lg:block">
                    <img :src="'https://tailwindui.com/img/ecommerce-images/product-page-02-secondary-product-shot.jpg'" alt="" class="w-full h-full object-center object-cover" />
                </div>
            </div>

            <!-- Product info -->
            <div class="max-w-2xl mx-auto pt-10 pb-16 px-4 sm:px-6 lg:max-w-7xl lg:pt-16 lg:pb-24 lg:px-8 lg:grid lg:grid-cols-3 lg:grid-rows-[auto,auto,1fr] lg:gap-x-8">
                <div class="lg:col-span-2 lg:border-r lg:border-gray-200 lg:pr-8">
                    <h1 class="text-2xl font-extrabold tracking-tight text-gray-900 sm:text-3xl">
                        {{ product.name }}
                    </h1>
                </div>

                <!-- Options -->
                <div class="mt-4 lg:mt-0 lg:row-span-3">
                    <h2 class="sr-only">Product information</h2>
                    <p class="text-3xl text-gray-900">{{ product.price }} ₽.</p>

                    <!-- Reviews -->
                    <div class="mt-6">
                        <h3 class="sr-only">Reviews</h3>
                        <div class="flex items-center">
                            <div class="flex items-center">
                                <StarIcon v-for="rating in [0, 1, 2, 3, 4]" :key="rating" :class="[reviews.average > rating ? 'text-gray-900' : 'text-gray-200', 'h-5 w-5 flex-shrink-0']" aria-hidden="true" />
                            </div>
                            <p class="sr-only">{{ reviews.average }} out of 5 stars</p>
                            <a :href="reviews.href" class="ml-3 text-sm font-medium text-indigo-600 hover:text-indigo-500">{{ reviews.totalCount }} reviews</a>
                        </div>
                    </div>

                    <div>
                        <h3 class="text-gray-900 font-medium">Brand</h3>
                        <div class="mt-4">
                            {{product.brand.name}}
                            <span>
                                    <img class="" alt="" :src="getImage">
                                </span>
                        </div>
                    </div>

                    <form class="mt-10" @submit.prevent="submit">
                        <button v-if="form.quantity === null" type="submit"
                                class="mt-10 w-full bg-indigo-600 border border-transparent rounded-md py-3
                                px-8 flex items-center justify-center text-base font-medium text-white hover:bg-indigo-700
                                focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500">
                            Add to bag
                        </button>
                        <div v-else>
                            <span @click="deleteProduct">Delete</span>
                            <input id="quantity" type="number" name="quantity" v-model="form.quantity">
                            <button type="submit"
                                    class="mt-10 w-full bg-indigo-600 border border-transparent rounded-md py-3
                                px-8 flex items-center justify-center text-base font-medium text-white hover:bg-indigo-700
                                focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500">
                                Add to bag
                            </button>
                        </div>
                    </form>
                </div>

                <div class="py-10 lg:pt-6 lg:pb-16 lg:col-start-1 lg:col-span-2 lg:border-r lg:border-gray-200 lg:pr-8">
                    <!-- Description and details -->
                    <div>
                        <h3 class="sr-only">Description</h3>

                        <div class="space-y-6">
                            <p class="text-base text-gray-900">{{ product.description }}</p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { StarIcon } from '@heroicons/vue/solid'
import { RadioGroup, RadioGroupLabel, RadioGroupOption } from '@headlessui/vue'
import {isEmpty} from "lodash";

export default {
    data(){
        return {
            form: {
                quantity: null,
            }
        }
    },
    components: {
        RadioGroup,
        RadioGroupLabel,
        RadioGroupOption,
        StarIcon,
    },
    props:{
        product:{
            type: Object,
            default: {},
        },
        reviews:{
            type: Object,
            default: { href: '#', average: 4, totalCount: 117 },
        },
    },
    computed:{
        getImage() {
            if(!isEmpty(this.product.brand.image))
            {
                return this.product.brand.image.url;
            }
            //todo: Убрать в переменную
            return '/pict/brand/no_icon.svg';
        },
    },
    mounted() {
        axios.get(route('basket.check',this.product.id))
            .then(response => {
                if(response.data.success === true)
                {
                    this.form.quantity = response.data.quantity;
                }
            });
    },
    methods:{
        submit() {
            // this.$inertia.post(route('basket.add', this.product.id));
            return axios.post(route('basket.add', this.product.id), this.form)
                .then(response => {
                    if(typeof response.data.quantity !== 'undefined' && response.data.quantity > 0)
                    {
                        this.form.quantity = response.data.quantity;
                    }
                })
        },
        deleteProduct() {
            return axios.delete(route('basket.remove', this.product.id))
                .then(response => {
                    if(typeof response.data.success)
                    {
                        this.form.quantity = null;
                    }
                })
        }
    }
}
</script>
